### Példa Gnuplot script alapvető illesztésre és ábrázolásra -> 1. ábra ###
### Valamint egy haladóbb példa több ábra egyszerre plotolására és bonyolultabb illesztésre -> 2. ábra ###
### windows alatt a scriptet kicsit módosítani kell ###
### Ez csak egy útmutató, nem black box! vagyis érdemes saját scriptet írni ez alajpján egy-egy ábrához ###
### Scriptet írta: Rozgonyi Kristóf, 2016 (tesztelve 5.0-ás Gnuploton) ###

#Állítsunk be az ábrafeliratokhoz utf8 kódolást, hogy az ékezetes karatktereket is meg tudjuk jeleníteni
set encoding utf8

### Adatok ellenőrzése ###
#Először nézzük meg az adatainkat egy sima plot paranccsal: az x értékek az 1., az y a 2. a hiba pedig a 3. oszlopban van 
p "gauss.dat" u 1:2:3 w e
#pause -1

##################################### Első ábra #############################################
#Állítsunk be címet a leendő ábránknak 16-os betűmérettel sans betűtípussal (színt RGB HEX kóddal adom meg)!
set title "Ábra címe" tc rgb "#00FF55" font "sans, 16" 

#Állítsuk be az x és az y ábrázolási tartományt!
set xrange[130:230]
set yrange[-10:100]

#Állítsuk be a tengelyszámozások méretét és az x tengelyen forgassuk el őket!
set xtics font ", 12" rotate by 45 right 
set ytics font ", 12"

#Állítsunk be másodlagos skálát!
set mxtics 4
set mytics 2

#Állítsunk be hálót!
set grid

#Állítsuk be az x és az y tengely feliratait, betűtípusát, méretét és színét! Valamint a tengelytől vett távolságát az offset paranccsal (x,y,z irányok, 0 az alapértelmezett)
set xlabel "x tengely [valamilyen mértékegység]" font "sans, 12" tc rgb "#FF0AB5" offset 0,-2.5,0
set ylabel "y tengely [valami más mértékegység]" font "sans, 12" tc rgb "#404040" offset 0,0,0

#Állítsuk be az adatok feliratának a színét, betűtípusát, méretét és a helyét! (tengelyeken %-osan megadva)
set key font "sans, 12" tc rgb "#FFB914" at graph 0.45,0.95

#Amennyiben logaritmikus skálát szeretnénk használni:
#set logscale x
#set logscale y

#definiáljuk az illesztendő Gauss-görbét! (pi standard változó a Gnuplotban, nekünk nem kell definiálni)
gauss(x) = a/(2*pi*s**2)**0.5*exp(-(x-m)**2/(2*s**2))

#Adjunk meg kezdeti értékeket az illesztett görbének!
s = -8
m = 185
a = 1100

#Illeszük rá az adatokra a fenti görbét mindhárom változója szerint!
fit gauss(x) "gauss.dat" using 1:2:3 via s, a, m

#Írjuk rá az ábrára az illesztett paramétereket és azok hibáját! (különböző számú tizedesjegyet írtam ki) Megadhatjuk továbbá a betűméretet és a színt. Valamint a feliratok pozícióját %-osan!
set label sprintf("{/Symbol \m} = %.2f +/- %.2f" ,m,m_err) font "sans, 12" tc rgb "#0493FF" at graph 0.05,0.4
set label sprintf("{/Symbol \s} = %.1f +/- %.1f",s,s_err) font "sans, 12" tc rgb "#0493FF" at graph 0.65,0.7

#Ábrázoljuk az adatokat és az illesztett görbét, a választott színekkel, pnt- és volnaltípusokkal és mérettel! (beállításokhoz lásd: test parancs)
p "gauss.dat" u 1:2:3 w e pt 7 ps 1.2 lc rgb "#000080" t "mért adatok", gauss(x) title "illesztett gauss" dt 4 lw 2 lc rgb "#800000"
pause -1

#Amennyiben az ábránkat menteni karjuk: (lehet hogy bizonyos beállításokat meg kell változtatni mert az nem ugyanaz mint amit az x11 terminal kidob)
#set term po enh eps c 
#set output 'elso_abra.eps'
#replot
#set term x11
#set output

##################################### Második ábra #############################################
#Itt nem nézek rá az adatokra.
#Ez egy haladóbb példa: több ábra készítése egyszerre
#Illetve itt hisztogramokra illesztek (itt nem kell elkészítenem a hisztogramokat, mert már eleve hisztogramokat olvasok be az adatfileból)

#Minden eddigi beállítás visszaállítása alapértelmezett üzemmódba:
reset

#Bállítom hogy több ábrát plotolhassak egyszerre: 2 ábrát fogok egymás fölé rajzolni
#Viszont itt csak akkor tudok menteni, ha a terminált előre beállírom valamilyen nem interaktív üzemmódba! -> Lásd gnuplot dokumentáció
set multiplot layout 1,1 rowsfirst

#Állítsuk be az x és az y ábrázolási tartományt!
set xrange [1.05:3]
set yrange [0:400]

#Hisztogramok kitöltésének és szélének a beállítása:
#set style fill solid border -1 #nem átlátszó
set style fill transparent solid 0.25 border -1 #25%-ban átlátszó

########################### Első subplot #################################
#Állítsuk be az x és az y tengely feliratait, betűtípusát és méretétt!
set xlabel "x tengely [valamilyen mértékegység]" font "sans, 12"
set ylabel "y tengely [valami 1]" font "sans, 12"

#Exponenciális háttér beállítása
f(x)=a*exp(b*x)+c

#Kezdeti értékek megadása
a=1023
b=-0.02
c=-900

#Illesztés több lépésben
fit f(x) "histogram_es_tobb_gaus.dat" u 1:2 via a
fit f(x) "histogram_es_tobb_gaus.dat" u 1:2 via a,b
fit f(x) "histogram_es_tobb_gaus.dat" u 1:2 via a,b,c

#Illesztés eredménye
#a               = 1188.63          +/- 7392         (621.9%)
#b               = -0.0837727       +/- 0.6228       (743.5%)
#c               = -930.007         +/- 7496         (806%)

#Exponenciális háttér definiálása ez alapján (több próbálkozás után)
f(x) = 1188.63*exp(x*-0.0837727)+-930.007

#Gaussok definiálása
g(x)=(a/s*sqrt(2*pi))*exp(-((x-m)**2)/(2*s**2))+(a2/s2*sqrt(2*pi))*exp(-((x-m2)**2)/(2*s2**2))

#Kezdeti értékek megadása
a=4
m=2.05
s=0.1
a2 = 4
m2 = 2.3
s2 = 0.8

#Illesztés több lépésben
fit [1.8:2.2] g(x) "tobb_gauss.dat" u 1:($2-f($1)) via a, s
fit [1.8:2.2] g(x) "tobb_gauss.dat" u 1:($2-f($1)) via a, m, s
fit [2.2:2.5] g(x) "tobb_gauss.dat" u 1:($2-f($1)) via a2, s2
fit [2.2:2.5] g(x) "tobb_gauss.dat" u 1:($2-f($1)) via a2, m2, s2

#Illesztés eredménye
#a               = 3.17996          +/- 0.6926       (21.78%)
#m               = 2.05018          +/- 0.01445      (0.7047%)
#s               = 0.0670297        +/- 0.02368      (35.33%)
#a2              = 3.95845          +/- 0.7275       (18.38%)
#m2              = 2.33694          +/- 0.01326      (0.5674%)
#s2              = 0.0656891        +/- 0.01844      (28.07%)

#Állítsuk be az adatok feliratának a helyét! (tengelyeken %-osan megadva)
set key at graph 0.45,0.9

#Valamilyen eredmények kiírása az ábrára:
set label sprintf("{/Symbol \m}_1 = 2.05 +/- 0.01") at graph 0.5,0.75
set label sprintf("{/Symbol \m}_2 = 2.33 +/- 0.01") at graph 0.65,0.6

#Y irányban a skála beállítása 0-tól 400-ig 100-asával lépkedve
set ytics border 0,100,500

#Subplot mérete és elhelyezkedésének beállítása a kimeneti képen (arányosan x és y irányban)
set size 1, 0.5
set origin 0.0,0.5

#Ábrázolás:
p "tobb_gauss.dat" u 1:2 w boxes lc rgb "#0493FF" t "1. hisztogram", g(x)+f(x) t "illesztett gaussok" dt 4 lw 3 lc rgb "#800000"

############################second plot#################################
#Teljesen hasonlóan a fentihez megcsinálom a második subplotot

#Állítsuk be az x és az y tengely feliratait, betűtípusát és méretétt!
set xlabel "x tengely [valamilyen más mértékegység]" font "sans, 12"
set ylabel "y tengely [valami 2]" font "sans, 12"

#Exponenciális háttér beállítása
f2(x)=a2*exp(b2*x)+c2

#Kezdeti értékek megadása
a2=1050
b2=-0.1
c2=-900

#Illesztés több lépésben
fit f2(x) "histogram_es_tobb_gaus.dat" u 1:3 via a2
fit f2(x) "histogram_es_tobb_gaus.dat" u 1:3 via a2,b2
fit f2(x) "histogram_es_tobb_gaus.dat" u 1:3 via a2,b2,c2

#Illesztés eredménye
#a2              = 3846.51          +/- 5.856e+04    (1522%)
#b2              = -0.0308765       +/- 0.5004       (1621%)
#c2              = -3521.9          +/- 5.866e+04    (1666%)

#Exponenciális háttér definiálása ez alapján (több próbálkozás után)
f2(x) = 3846.51*exp(x*-0.0308765)+-3521.9

#Gaussok definiálása
g2(x)=(a3/s3*sqrt(2*pi))*exp(-((x-m3)**2)/(2*s3**2))+(a4/s4*sqrt(2*pi))*exp(-((x-m4)**2)/(2*s4**2))

#Kezdeti értékek megadása
a3=4
m3=2.05
s3=0.1
a4 = 4
m4 = 2.3
s4 = 0.8

#Illesztés több lépésben
fit [1.8:2.2] g2(x) "tobb_gauss.dat" u 1:($3-f($1)) via a3, s3
fit [1.8:2.2] g2(x) "tobb_gauss.dat" u 1:($3-f($1)) via a3, m3, s3
fit [2.2:2.5] g2(x) "tobb_gauss.dat" u 1:($3-f($1)) via a4, s4
fit [2.2:2.5] g2(x) "tobb_gauss.dat" u 1:($3-f($1)) via a4, m4, s4

#Illesztés eredménye
#a3              = 5.46648          +/- 0.276        (5.05%)
#m3              = 2.03953          +/- 0.003371     (0.1653%)
#s3              = 0.0612197        +/- 0.005793     (9.463%)
#a4              = 5.44583          +/- 0.4138       (7.599%)
#m4              = 2.34172          +/- 0.005129     (0.219%)
#s4              = 0.0554043        +/- 0.01216      (21.96%)

#Az előző ábrára rajzolt eredmények törlése majd az új eredmények beállítása
unset label

set label sprintf("{/Symbol \m}_1 = 2.05 +/- 0.01") at graph 0.5,0.9
set label sprintf("{/Symbol \m}_2 = 2.33 +/- 0.01") at graph 0.7,0.65

#Subplot mérete és elhelyezkedésének beállítása a kimeneti képen (arányosan x és y irányban)
set size 1, 0.5
set origin 0.0,0.0

#Ábrázolás:
p "tobb_gauss.dat" u 1:3 w boxes lc rgb "#0493FF" t "2. hisztogram", g2(x)+f2(x) t "illesztett gaussok" dt 4 lw 3 lc rgb "#800000"
pause -1

#Amennyiben tovább szeretnénk dolgozni (mondjuk elmenteni a képet) és szükséges lenne
#unset multiplot
